package cn.com.qmth.stmms.biz.exam.bean;

import java.util.Date;

import cn.com.qmth.stmms.biz.exam.model.ExamSubject;
import cn.com.qmth.stmms.biz.mark.model.MarkLibrary;
import cn.com.qmth.stmms.common.enums.LibraryStatus;
import io.swagger.annotations.ApiModelProperty;

public class MarkLibraryVo {

    @ApiModelProperty("任务id")
    private Integer id;

    /**
     * 考试ID
     */
    @ApiModelProperty("考试ID")
    private Integer examId;

    /**
     * 科目CODE
     */
    @ApiModelProperty("科目CODE")
    private String subjectCode;

    /**
     * 大题序号
     */
    @ApiModelProperty("分组号")
    private Integer groupNumber;

    /**
     * 考生编号
     */
    @ApiModelProperty("考生id")
    private Integer studentId;

    /**
     * 准考证号
     */
    @ApiModelProperty("准考证号")
    private String examNumber;

    /**
     * 考生密号
     */
    @ApiModelProperty("考生密号")
    private String secretNumber;

    /**
     * 多评任务编号，单评时为1
     */
    @ApiModelProperty("多评任务编号，单评时为1")
    private Integer taskNumber;

    /**
     * 任务状态
     */
    @ApiModelProperty("任务状态")
    private LibraryStatus status;

    /**
     * 评卷员
     */
    @ApiModelProperty("评卷员id")
    private Integer markerId;

    /**
     * 评卷时间
     */
    @ApiModelProperty("评卷时间")
    private Date markerTime;

    /**
     * 评卷员给分总分
     */
    @ApiModelProperty("评卷员给分总分")
    private Double markerScore;

    /**
     * 评卷员给分明细
     */
    @ApiModelProperty("评卷员给分明细")
    private String markerScoreList;

    /**
     * 评卷时长
     */
    @ApiModelProperty("评卷时长")
    private Integer markerSpent;

    /**
     * 科组长
     */
    @ApiModelProperty("科组长id")
    private Integer headerId;

    /**
     * 科组长评卷时间
     */
    @ApiModelProperty("科组长评卷时间")
    private Date headerTime;

    /**
     * 科组长给分总分
     */
    @ApiModelProperty("科组长给分总分")
    private Double headerScore;

    /**
     * 科组长给分明细
     */
    @ApiModelProperty("科组长给分明细")
    private String headerScoreList;

    /**
     * 未作答的步骤数量
     */
    @ApiModelProperty("未作答的步骤数量")
    private Integer unansweredCount;

    @ApiModelProperty("打回原因")
    private String rejectReason;

    @ApiModelProperty("评卷员登录名")
    private String markerLoginName;

    @ApiModelProperty("分组名")
    private String title;

    @ApiModelProperty("科组长登录名")
    private String headerLoginName;

    @ApiModelProperty("科目信息")
    private ExamSubject subject;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getExamId() {
        return examId;
    }

    public void setExamId(Integer examId) {
        this.examId = examId;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public Integer getGroupNumber() {
        return groupNumber;
    }

    public void setGroupNumber(Integer groupNumber) {
        this.groupNumber = groupNumber;
    }

    public Integer getStudentId() {
        return studentId;
    }

    public void setStudentId(Integer studentId) {
        this.studentId = studentId;
    }

    public String getExamNumber() {
        return examNumber;
    }

    public void setExamNumber(String examNumber) {
        this.examNumber = examNumber;
    }

    public String getSecretNumber() {
        return secretNumber;
    }

    public void setSecretNumber(String secretNumber) {
        this.secretNumber = secretNumber;
    }

    public Integer getTaskNumber() {
        return taskNumber;
    }

    public void setTaskNumber(Integer taskNumber) {
        this.taskNumber = taskNumber;
    }

    public LibraryStatus getStatus() {
        return status;
    }

    public void setStatus(LibraryStatus status) {
        this.status = status;
    }

    public Integer getMarkerId() {
        return markerId;
    }

    public void setMarkerId(Integer markerId) {
        this.markerId = markerId;
    }

    public Date getMarkerTime() {
        return markerTime;
    }

    public void setMarkerTime(Date markerTime) {
        this.markerTime = markerTime;
    }

    public Double getMarkerScore() {
        return markerScore;
    }

    public void setMarkerScore(Double markerScore) {
        this.markerScore = markerScore;
    }

    public String getMarkerScoreList() {
        return markerScoreList;
    }

    public void setMarkerScoreList(String markerScoreList) {
        this.markerScoreList = markerScoreList;
    }

    public Integer getMarkerSpent() {
        return markerSpent;
    }

    public void setMarkerSpent(Integer markerSpent) {
        this.markerSpent = markerSpent;
    }

    public Integer getHeaderId() {
        return headerId;
    }

    public void setHeaderId(Integer headerId) {
        this.headerId = headerId;
    }

    public Date getHeaderTime() {
        return headerTime;
    }

    public void setHeaderTime(Date headerTime) {
        this.headerTime = headerTime;
    }

    public Double getHeaderScore() {
        return headerScore;
    }

    public void setHeaderScore(Double headerScore) {
        this.headerScore = headerScore;
    }

    public String getHeaderScoreList() {
        return headerScoreList;
    }

    public void setHeaderScoreList(String headerScoreList) {
        this.headerScoreList = headerScoreList;
    }

    public Integer getUnansweredCount() {
        return unansweredCount;
    }

    public void setUnansweredCount(Integer unansweredCount) {
        this.unansweredCount = unansweredCount;
    }

    public String getRejectReason() {
        return rejectReason;
    }

    public void setRejectReason(String rejectReason) {
        this.rejectReason = rejectReason;
    }

    public String getMarkerLoginName() {
        return markerLoginName;
    }

    public void setMarkerLoginName(String markerLoginName) {
        this.markerLoginName = markerLoginName;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getHeaderLoginName() {
        return headerLoginName;
    }

    public void setHeaderLoginName(String headerLoginName) {
        this.headerLoginName = headerLoginName;
    }

    public ExamSubject getSubject() {
        return subject;
    }

    public void setSubject(ExamSubject subject) {
        this.subject = subject;
    }

    public static MarkLibraryVo of(MarkLibrary from) {
        if (from == null) {
            return null;
        }
        MarkLibraryVo ret = new MarkLibraryVo();
        ret.setId(from.getId());
        ret.setExamId(from.getExamId());
        ret.setSubjectCode(from.getSubjectCode());
        ret.setGroupNumber(from.getGroupNumber());
        ret.setStudentId(from.getStudentId());
        ret.setExamNumber(from.getExamNumber());
        ret.setSecretNumber(from.getSecretNumber());
        ret.setTaskNumber(from.getTaskNumber());
        ret.setStatus(from.getStatus());
        ret.setMarkerId(from.getMarkerId());
        ret.setMarkerTime(from.getMarkerTime());
        ret.setMarkerScore(from.getMarkerScore());
        ret.setMarkerScoreList(from.getMarkerScoreList());
        ret.setMarkerSpent(from.getMarkerSpent());
        ret.setHeaderId(from.getHeaderId());
        ret.setHeaderTime(from.getHeaderTime());
        ret.setHeaderScore(from.getHeaderScore());
        ret.setHeaderScoreList(from.getHeaderScoreList());
        ret.setUnansweredCount(from.getUnansweredCount());
        ret.setRejectReason(from.getRejectReason());
        ret.setMarkerLoginName(from.getMarkerLoginName());
        ret.setTitle(from.getTitle());
        ret.setHeaderLoginName(from.getHeaderLoginName());
        ret.setSubject(from.getSubject());
        return ret;
    }

}
