package cn.com.qmth.stmms.biz.exam.bean;

import cn.com.qmth.stmms.biz.exam.model.ExamSubject;
import cn.com.qmth.stmms.biz.exam.model.Marker;
import cn.com.qmth.stmms.common.enums.MarkMode;
import io.swagger.annotations.ApiModelProperty;

public class MarkerVo {

    @ApiModelProperty("评卷员id")
    private Integer id;

    @ApiModelProperty("")
    private Integer examId;

    @ApiModelProperty("")
    private String subjectCode;

    @ApiModelProperty("分组号")
    private Integer groupNumber;

    @ApiModelProperty("用户id")
    private Integer userId;

    @ApiModelProperty("启用禁用")
    private Boolean enable;

    @ApiModelProperty("评卷模式")
    private MarkMode mode;

    @ApiModelProperty("任务数")
    private Integer topCount;

    @ApiModelProperty("登录名")
    private String loginName;

    @ApiModelProperty("姓名")
    private String name;

    @ApiModelProperty("")
    private ExamSubject subject;

    @ApiModelProperty("分组名")
    private String title;

    @ApiModelProperty("已评数量")
    private Long markedCount;

    @ApiModelProperty("")
    private Long markedCountNa;

    @ApiModelProperty("正在评卷")
    private Long currentCount;

    @ApiModelProperty("是否正在重置")
    private Boolean reseting;

    /**
     * 班级数量
     */
    @ApiModelProperty("绑定班级")
    private Long classCount;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getExamId() {
        return examId;
    }

    public void setExamId(Integer examId) {
        this.examId = examId;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public Integer getGroupNumber() {
        return groupNumber;
    }

    public void setGroupNumber(Integer groupNumber) {
        this.groupNumber = groupNumber;
    }

    public Integer getUserId() {
        return userId;
    }

    public void setUserId(Integer userId) {
        this.userId = userId;
    }

    public Boolean getEnable() {
        return enable;
    }

    public void setEnable(Boolean enable) {
        this.enable = enable;
    }

    public MarkMode getMode() {
        return mode;
    }

    public void setMode(MarkMode mode) {
        this.mode = mode;
    }

    public Integer getTopCount() {
        return topCount;
    }

    public void setTopCount(Integer topCount) {
        this.topCount = topCount;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public ExamSubject getSubject() {
        return subject;
    }

    public void setSubject(ExamSubject subject) {
        this.subject = subject;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Long getMarkedCount() {
        return markedCount;
    }

    public void setMarkedCount(Long markedCount) {
        this.markedCount = markedCount;
    }

    public Long getMarkedCountNa() {
        return markedCountNa;
    }

    public void setMarkedCountNa(Long markedCountNa) {
        this.markedCountNa = markedCountNa;
    }

    public Long getCurrentCount() {
        return currentCount;
    }

    public void setCurrentCount(Long currentCount) {
        this.currentCount = currentCount;
    }

    public Boolean getReseting() {
        return reseting;
    }

    public void setReseting(Boolean reseting) {
        this.reseting = reseting;
    }

    public Long getClassCount() {
        return classCount;
    }

    public void setClassCount(Long classCount) {
        this.classCount = classCount;
    }

    public static MarkerVo of(Marker from) {
        if (from == null) {
            return null;
        }
        MarkerVo ret = new MarkerVo();
        ret.setId(from.getId());
        ret.setExamId(from.getExamId());
        ret.setSubjectCode(from.getSubjectCode());
        ret.setGroupNumber(from.getGroupNumber());
        ret.setUserId(from.getUserId());
        ret.setEnable(from.isEnable());
        ret.setMode(from.getMode());
        ret.setTopCount(from.getTopCount());
        ret.setLoginName(from.getLoginName());
        ret.setSubject(from.getSubject());
        ret.setTitle(from.getGroup().getTitle());
        ret.setMarkedCount(from.getMarkedCount());
        ret.setMarkedCountNa(from.getMarkedCountNa());
        ret.setCurrentCount(from.getCurrentCount());
        ret.setReseting(from.isReseting());
        ret.setClassCount(from.getClassCount());
        ret.setName(from.getUser().getName());
        return ret;
    }
}
