package cn.com.qmth.stmms.common.domain;

import cn.com.qmth.stmms.biz.school.model.School;
import cn.com.qmth.stmms.biz.user.model.User;
import cn.com.qmth.stmms.common.enums.Role;

import java.util.Set;

public class ApiUser {

    private Integer schoolId;

    private User user;

    private School schoolData;

    private Role role;

    private Set<String> subjectCodeSet;

    public ApiUser(School school) {
        schoolData = school;
        schoolId = school.getId();
        role = Role.SCHOOL_DEV;
    }

    public ApiUser(User user) {
        this.user = user;
        schoolId = user.getSchoolId();
        role = user.getRole();
    }

    public Integer getSchoolId() {
        return schoolId;
    }

    public Role getRole() {
        return role;
    }

    public User getUser() {
        return user;
    }

    public School getSchoolData() {
        return schoolData;
    }

    public Set<String> getSubjectCodeSet() {
        return subjectCodeSet;
    }

    public void setSubjectCodeSet(Set<String> subjectCodeSet) {
        this.subjectCodeSet = subjectCodeSet;
    }
    public boolean isSubjectHeader() {
        return (role == Role.SUBJECT_HEADER) || (role == Role.COLLEGE_ADMIN);
    }

    public boolean isSchoolAdmin() {
        return role == Role.SCHOOL_ADMIN;
    }

    public boolean isSchoolViewer() {
        return role == Role.SCHOOL_VIEWER;
    }

    public boolean isMarker() {
        return role == Role.MARKER;
    }

    public boolean isInspector() {
        return role == Role.INSPECTOR;
    }
}
